/***************************************************************************
                          game.h  -  description
                             -------------------
    begin                : Tue Feb 29 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAME_H
#define GAME_H

/**
  *@author Michael Speck
  */

class Wave;

#include "sdl.h"
#include "tetris.h"
#include "menumanager.h"

class Game{
public: 
	Game();
	~Game();
	void Run();
private:
	SDL			*sdl;
	SDLSurface	*title;
	SDLSurface	*logo;
	int			logo_x;
	int			logo_y;
	SDLFont		*f_menu_w;
	SDLFont		*f_menu_b;
	SDLFont		*f_hiscore;
	SDLFont		*f_enlgt_hiscore;
	SDLFont		*f_copy;
	MenuManager	*mm;
	Tetris		*tetris;
	char		val_ctrl_keys[SDLK_LAST];
	Wave		*snd_menu;
protected:
	void ShowHiScore(int h, int e);
};

#endif
