/***************************************************************************
                          hiscore.cpp  -  description
                             -------------------
    begin                : Wed Mar 1 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "hiscore.h"
#include "defs.h"
#include <string.h>

HiScore::HiScore(char *f)
{
	strcpy(filename, "");
	entry_num = 0;
	entries = 0;
	in_src_dir = 0;
	if (Load(f) == RET_ERROR)
		Create();
}

HiScore::~HiScore()
{
	if (entries) delete entries;
}

void HiScore::Create()
{
	entry_num = 10;
	if (entries) delete entries;
	entries = new HiScoreEntry[entry_num];
	for (int i = 0; i < entry_num; i++) {
		entries[i].level = 0;
		entries[i].score = 0;
		entries[i].lines = 0;
		strcpy(entries[i].name, "<empty>");
	}
}

int HiScore::Load(char *f)
{
	FILE *file = 0;/* = fopen(f, "r");
	if (filename[0] == 0)
		strcpy(filename, f);*/
	if (file == 0) {
	    //try full path
    	char path[strlen(HI_DIR)+ strlen(f) + 1];
	    sprintf(path, "%s%s", HI_DIR, f);
	    in_src_dir = 1;
	    if ((file = fopen(path, "r")) == 0) {
		    printf("hiscore '%s' not found...\n", f);
		    return RET_ERROR;
		}
	}
	fread(&entry_num, sizeof(int), 1, file);
	if (entries) delete entries;
	entries = new HiScoreEntry[entry_num];
	fread(entries, sizeof(HiScoreEntry), entry_num, file);
	fclose(file);
	strcpy(filename, f);
	return RET_OK;
}

void HiScore::Save(char *f)
{
	if (entry_num == 0 || f[0] == 0) {
		printf("cannot save empty hiscore...\n");
		return;
	}
	char path[strlen(HI_DIR) + strlen(f) + 1];
	if (in_src_dir)
	    sprintf(path, "%s%s", HI_DIR, f);
    else
        sprintf(path, "%s", f);
	FILE *file = fopen(path, "w");
	if (file == 0) {
	    printf("cannot write '%s': permission denied...\n", path);
	    return;
	}
	fwrite(&entry_num, sizeof(int), 1, file);
	fwrite(entries, sizeof(HiScoreEntry), entry_num, file);
	fclose(file);
}

void HiScore::Save()
{
	Save(filename);
}

HiScoreEntry HiScore::Entry(int i)
{
	i = (i < 0) ? 0 : (i >= entry_num) ? entry_num - 1 : i;
	return entries[i];
}

int HiScore::CheckEntry(HiScoreEntry *entry)
{
	for (int i = 0; i < entry_num; i++)
		if (entry->score > entries[i].score || (entry->score == entries[i].score && entry->lines < entries[i].lines)) {
			//found
			for (int j = entry_num - 1; j > i; j--)
				entries[j] = entries[j - 1];
			entries[i] = *entry;
			return i;
		}
		
	return -1;
}
