/***************************************************************************
                          shrapnell.h  -  description
                             -------------------
    begin                : Mon Mar 6 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHRAPNELL_H
#define SHRAPNELL_H


/**
  *@author Michael Speck
  */

#include "sdl.h"

struct Vector {
	float x, y;
};

class Shrapnell {
public:
	Shrapnell();
	Shrapnell(SDL_Surface *dest, int px, int py, int sw, int sh, Vector sv, Vector av, float pct_ch);
	~Shrapnell();
	void GetBackgnd();
	void Show(SDL_Rect *rects, int *rect_num);
	void Hide();
	int  Update(int ms);
	Shrapnell* Next();
	Shrapnell* Prev();
	void SetNext(Shrapnell *n);
	void SetPrev(Shrapnell *p);
	void SetSDL(SDL *s);
private:
	SDL_Surface	*screen;
	SDLSurface	*backgnd;
	SDLSurface	*shrapnell;
	int x;
	int y;
	int	old_x;
	int	old_y;
	int w;
	int h;
	Vector	dir; //initial direction
	Vector	dir_ch; //direction's change per msec
	float	cur_x;
	float	cur_y;
	Shrapnell	*next;
	Shrapnell	*prev;
	float	pct; //trancparency
	float	pct_ch; //change per msec
};

#endif
